clear all;close all;clc %#ok<CLALL>
[Xr,~,raw]=xlsread('Final Data.xlsx',1,'A3:BY774');
I=[2:3 4 5 6 7 8:12 14 16:22 24:28 29:41 43:72];
CarBrand=xlsread('Final Data (car brand).xlsx',1,'B3:D774');

% Q refers to the question number in the paper&pencil questionnaire (reveald_English.docx)
% artQ refers to the question number in the article

% X2 = Year of manufacture (Q2, artQ2)
% X3 = Purchased in the year (Q3, artQ3)
% X4 = Vehicle use (Q4, artQ4)
% X5 = Days per week travel (Q5, artQ5)
% X6 = Hours per day (Q6, artQ6)
% X7 = Km per year (Q7, artQ7)
% X8-12 = Purpose of driving (Q8, artQ8)
% X13 = Do you drive between 12 am and 6 am? (Q9) (not included in all questionnaires)
% X14 = Percentage driving on country roads (Q10, artQ9)
% X15 = Percentage driving on highways and motorways (Q11) (not included in all questionnaires)
% X16 = How much faster is your driving speed usually, compared with that of others? (Q12, artQ10)
% X17 = What do you think is the probability of you having a car accident? (Q13, artQ11)
% X18 = If you, as a driver, have an accident, what do you think is the probability of it being fatal or causing severe injury? (Q14, artQ12)
% X19-22 = Accident questions (Q16-Q19, artQ13-Q16)
% X23 = How many times in the last month have you faced the risk of crash but avoided it? (Q20) (not included in all questionnaires)
% X24-28 = Ticket questions (Q21, artQ17)
% X29-30 = Number of trips (Q22, artQ18)
% X31 = How many times in a year do you usually get a speeding ticket? (Q23, artQ19)
% X32 = Has your driving license ever been confiscated by the police? (Q24, artQ20)
% X33 = Sleep quality (Q26, artQ21)
% X34 = Marital status (Q27, artQ22)
% X35 = Educational level (Q28, artQ23)
% X36 = Who owns the vehicle you usually drive? (Q29, artQ24)
% X37 = How many vehicles do you own (Q30, artQ25)
% X38 = In what year did you obtain your driving license? (Q34, artQ29), converted to driving experience in years
% X39 = Have you been involved in any fatal accidents in the last three years? (Q36, artQ31)
% X40 = Year of birth (Q31, artQ26)
% X41 = Gender (Q32, artQ27)
% X42 = Municipal district of your house (Q33, artQ28)
% X43 = Since what year have you been actually driving? (Q35, artQ30), converted to driving experience in years
% X44-72 = DBQ (Q37, artQ32-60)

X=NaN(size(raw,1),72);
X(:,2)=Xr(:,3)+621;X(X(:,2)==0,2)=NaN;% https://en.wikipedia.org/wiki/Solar_Hijri_calendar
X(:,3)=Xr(:,4)+1921;X(X(:,3)==0,3)=NaN; % https://en.wikipedia.org/wiki/Solar_Hijri_calendar
X(:,4)=strcmp(raw(:,5),'Private')+strcmp(raw(:,5),'Private driver')+2*strcmp(raw(:,5),'Taxi')+3*strcmp(raw(:,5),'Transfer of goods')+4*strcmp(raw(:,5),'Public')+5*strcmp(raw(:,5),'Out of town trip');
X(X(:,4)==0,4)=NaN;
X(:,5)=cell2mat(raw(:,6));
X(:,6)= 1*strcmp(raw(:,7),'Less than half ')+2*strcmp(raw(:,7),'Half an hour to 1 ') +3*strcmp(raw(:,7),'1 to 2')+4*strcmp(raw(:,7),'2 to 4')+5*strcmp(raw(:,7),'4 to 8 ')+6*strcmp(raw(:,7),'More than 8');
X(X(:,6)==0,6)=NaN;
X(:,7)=Xr(:,8); % How many kilometres approximately do you drive per year?
X(:,8:12)=Xr(:,9:13)+1; %
X(sum(X(:,8:12),2)==5,8:12)=NaN;
X(:,13)=NaN; % different response options, excluded
X(:,14)=1*strcmp(raw(:,15),'0-20')+2*strcmp(raw(:,15),'20-40') +3*strcmp(raw(:,15),'40-60')+4*strcmp(raw(:,15),'60-80')+5*strcmp(raw(:,15),'80-100');
X(X(:,14)==0,14)=NaN;
X(:,15)=NaN;
X(:,16:18)=Xr(:,17:19);
X(:,19:22)=Xr(:,21:24)+1;
X(:,24:28)=strcmp(raw(:,26:30),'No tickets')+2*strcmp(raw(:,26:30),'1 ticket')+3*strcmp(raw(:,26:30),'2 tickets')+4*strcmp(raw(:,26:30),'3 or 4 tickets')+5*strcmp(raw(:,26:30),'5-10 tickets')+6*strcmp(raw(:,26:30),'More than 10 tickets'); % tickets
X(X(:,24)==0,24)=NaN;X(X(:,25)==0,25)=NaN;X(X(:,26)==0,26)=NaN;X(X(:,27)==0,27)=NaN;X(X(:,28)==0,28)=NaN;
X(:,29:31)=strcmp(raw(:,31:33),'Never')+2*strcmp(raw(:,31:33),'1 or 2 times')+3*strcmp(raw(:,31:33),'3-6 times')+4*strcmp(raw(:,31:33),'6-12 times')+5*strcmp(raw(:,31:33),'More than 12 times');
X(X(:,29)==0,29)=NaN;
X(X(:,30)==0,30)=NaN;
X(X(:,31)==0,31)=NaN;
X(:,32)= Xr(:,34)+1; % Driving license confiscated
X(:,33)=Xr(:,36); % Sleep quality Q26, artQ21
X(:,34)=strcmp(raw(:,37),'Bachelor')+2*strcmp(raw(:,37),'Married')+3*strcmp(raw(:,37),'Seprated/divorced');
X(X(:,34)==0,34)=NaN;
X(:,35)=strcmp(raw(:,38),'Reading and Writing')+2*strcmp(raw(:,38),'Middle school')+3*strcmp(raw(:,38),'High school diploma')+4*strcmp(raw(:,38),'BSc')+5*strcmp(raw(:,38),'MSc')+6*strcmp(raw(:,38),'PhD');
X(X(:,35)==0,35)=NaN;
X(:,36)=strcmp(raw(:,39),'myself')+2*strcmp(raw(:,39),'father')+3*strcmp(raw(:,39),'mother')+4*strcmp(raw(:,39),'spouse')+5*strcmp(raw(:,39),'relative')+6*strcmp(raw(:,39),'organiation');
X(X(:,36)==0,36)=NaN;
temp=raw(:,40);
for i=1:length(temp)
    temp2=cell2mat(temp(i));
    if isstr(temp2) %#ok<DISSTR>
        temp2=str2double(temp2);
    end
    X(i,37)=1+temp2;
end
X(strcmp(temp,'more than 3'),37)=5; % How many vehicles do you own?
X(:,39)= Xr(:,47)+1; % Have you been involved in any fatal accidents in the last three years?
X(:,40)=2015-(cell2mat(raw(:,41))+621); % Age (converted from year of birth)

X(:,38)=cell2mat(raw(:,45))-cell2mat(raw(:,41)); % Age of obtaining driving license = year of obtaining driver's license - year of birth
X(X(:,38)<17,38)=NaN; % Assume minimum of 17 years, discard otherwise
X(:,38)=X(:,40)-X(:,38); % Driving experience in years = Age - Age of obtaining driving license

X(:,41)=strcmp(raw(:,42),'female')+2*strcmp(raw(:,42),'male');
X(X(:,41)==0,41)=NaN;
X(:,42)=str2double(raw(:,43)); % District

X(:,43)=cell2mat(raw(:,46))-cell2mat(raw(:,41)); % Age actually started driving = year actually started driving - year of birth
X(X(:,43)<13,43)=NaN; % Assume minimum of 13, discard otherwise
X(:,43)=X(:,40)-X(:,43); % Driving experience in years = Age - Age actually started driving

temp=raw(:,[48:64 66:77]);
for i=1:size(temp,1) % loop over participants
    for i2=1:size(temp,2) % loop over DBQ variables
        try
            X(i,43+i2)=1+cell2mat(temp(i,i2));
        catch error
            X(i,43+i2)=NaN*strcmp(temp(i),'');
        end
    end
end
%%
disp('Distribution of full dataset (N = 772)')
disp([sum(isnan(X(:,I)))' histc(X(:,I),0:8)' sum(X(:,I)>=9)'])
disp('Percentage missing values ranges between before filtering')
disp([min(100*(sum(isnan(X(:,I)))'./size(X,1))) max(100*(sum(isnan(X(:,I)))'./size(X,1)))])
finished_questionnaire=find(sum(isnan(X(:,I(end-1:end))),2)==0); % find participants without missing values in the last two questions
X=X(finished_questionnaire,:); % 712 participants left)

CarBrand=CarBrand(finished_questionnaire,:);
Xunfiltered=X;
temp=[19:22 24:31];
for i=1:length(temp) % loop over variables
    X(isnan(X(:,temp(i))),temp(i))=1; % replace NaN with 1 (i.e., no accidents/tickets)
end

X(X(:,20)>X(:,19),19:20)=NaN; % more minor and damage accidents in 1 year than in 3 years
X(X(:,22)>X(:,21),21:22)=NaN; % more fatal or injury accidents in 1 year than in 3 years

disp('Distribution after excluding participants who did not complete the questionnaire (based on the last two items), and imputing zero for missing questions marked in orange (N = 712)')
disp([sum(isnan(X(:,I)))' histc(X(:,I),0:8)' sum(X(:,I)>=9)'])
disp('Percentage missing values, range')
disp([min(100*(sum(isnan(X(:,I)))'./size(X,1))) max(100*(sum(isnan(X(:,I)))'./size(X,1)))])
%%
disp('Percentage respondents with Pride, 206, 405 (Q1, artQ1)')
disp((100*nansum(CarBrand)./(size(CarBrand,1)-sum(strcmp(raw(:,2),'')))))
disp('Percentage of participants with year of manufacture <=2010 (Q1, artQ2)')
disp(100*nansum(X(:,2)<=2010)/nansum(X(:,2)>0))
disp('Purchased a new vehicle')
disp(100*sum(X(:,2)==X(:,3))/sum(~isnan(X(:,2)+X(:,3))))
disp('Percentage of participants vehicle use private (Q4, artQ4)')
disp(100*sum(X(:,4)==1)./sum(X(:,4)>=1))
disp('Percentage of participants driving 4 or more days per week (Q5, artQ5)')
disp(100*sum(X(:,5)>=4)./sum(X(:,5)>=1))
disp('Percentage of participants driving less than 2 hours per day (Q6, artQ6)')
disp(100*sum(X(:,6)<=3)./sum(X(:,6)>=1))
disp('Average mileage')
disp(nanmean(X(:,7)))
disp('Percentage business, education, shopping, excursion, picking up family members (Q8, artQ8)')
disp(100*nansum(X(:,8:12)-1)./sum(sum(X(:,8:12),2)-5>=1))
disp('Percentage business, education, shopping, excursion, picking up family members ONLY (Q8, artQ8)')
temp=find(sum(X(:,8:12),2)-5==1);
disp(100*sum(X(temp,8:12)-1)./sum(sum(X(:,8:12),2)-5>=1)) %#ok<*FNDSB>
disp('Percentage driving on country roads 0-20% of their time (Q10, artQ9)')
disp(100*sum(X(:,14)==1)./sum(X(:,14)>=1))
disp('Percentage driving faster than average (Q12, artQ10)')
disp(100*sum(X(:,16)>=4)./sum(X(:,16)>=1))
disp('Percentage reporting a not high or very high probability of having a car accident (Q13, artQ11)')
disp(100*sum(X(:,17)<=3)./sum(X(:,17)>=1))
disp('Percentage reporting very low or low probability of accident being fatal or causing severe injury (Q14, artQ12)')
disp(100*sum(X(:,18)<=2)./sum(X(:,18)>=1))
disp('Percentage not being at fault in minor and damage accidents? (Q16, artQ13)')
disp(100*sum(X(:,19)==1)./sum(X(:,19)>=1))
disp('Percentage not being at fault in severe / injury accidents? (Q18, artQ15)')
disp(100*sum(X(:,21)==1)./sum(X(:,21)>=1))
disp('Percentage of respondents not having received tickets for 1. speed limit, 2. illegal overtaking, 3. not fastening the seatbelt, 4. talking on the phone')
disp(100*sum(X(:,[24 25 27 28])==1)./sum(X(:,[24 25 27 28])>=1))
disp('Percentage driving for <100 km trips? (Q22, artQ18)')
disp(100*sum(X(:,29)>=2)./sum(X(:,29)>=1))
disp('Percentage driving for >100 km trips? (Q22, artQ18)')
disp(100*sum(X(:,30)>=2)./sum(X(:,30)>=1))
disp('Percentage sleeping well (Q26, artQ21)')
disp(100*sum(X(:,33)>=4)./sum(X(:,33)>=1))
disp('Percentage single, married, divorced? (Q27, artQ22)')
disp(transpose(100*histc(X(:,34),1:3)./sum(X(:,34)>=1)))
disp('Percentage having university education, i.e. BSc or higher (Q28, artQ23)')
disp(100*sum(X(:,35)>=4)./sum(X(:,35)>=1))
disp('Percentage participants with vehicle = own (Q29, artQ24)')
disp(100*sum(X(:,36)==1)./sum(X(:,36)>=1))
disp('Percentage participants who do not own a vehicle (Q30, artQ25)')
disp(100*sum(X(:,37)==1)./sum(X(:,37)>=1))
disp('Percentage participants who own 1 vehicle (Q30, artQ25)')
disp(100*sum(X(:,37)==2)./sum(X(:,37)>=1))
disp('Mean number of vehicles owned (Q30, artQ25)')
disp(nanmean(X(:,37))-1)
disp('Mean,min,max age of participants (Q31, artQ26)')
disp([nanmean(X(:,40)) nanmin(X(:,40)) nanmax(X(:,40))])
disp('Percentage males (Q32, artQ27)')
disp(100*sum(X(:,41)==2)./sum(X(:,41)>=1))
disp('Percentage with more than 3 years actual experience (Q34, artQ29)')
disp(100*sum(X(:,38)>3)./sum(X(:,38)>=0))
disp('Percentage with more than 3 years actual experience (Q35, artQ30)')
disp(100*sum(X(:,43)>3)./sum(X(:,43)>=0))
disp('Number of drivers involved in fatal accidents')
disp(sum(X(:,39)==2))
X(X(:,34)==3,34)=1; % recode divorced (3) into 1 (bachelor)
disp('Means, standard deviations, and kurtosis of the filtered data (N = 712)')
Xunfiltered(Xunfiltered(:,34)==3,34)=1; % recode divorced (3) into 1 (bachelor)
disp([nanmean(X(:,I))' nanstd(X(:,I))' kurtosis(X(:,I))'])
%%
Q13=X(:,19); % Q16, artQ13 (untransformed, used later for logistic regression)
Xr=tiedrank(X);Xunfiltered=tiedrank(Xunfiltered);Xr(:,42)=X(:,42);Xr(:,1)=CarBrand(:,1);X=Xr; % rank transformation (except for municipal district and car brand)
DBQ=X(:,44:72);
DBQt=knnimpute(DBQ')';
%% PCA and scree plot
r=corr(DBQt,'rows','pairwise');
lding=pcao(r,3);
eigr=sort(eig(r),'descend');
disp('Percentage variance explained')
varexplained=100*(eigr./sum(eigr));
disp(varexplained)
lding=rotatefactors(lding,'method','promax');
for i=1:size(lding,2)
    if mean(lding(:,i))<0;lding(:,i)=-lding(:,i);end
end
figure;plot(eigr,'k-o','Linewidth',3)
ylabel('Eigenvalue')
xlabel('Component number')
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',24)
set(gca,'LooseInset', [0.01 0.01 0.01 0.01],'xtick',[1 5:5:100]);
set(gca,'xlim',[.5 length(r)+.5],'ylim',[0 8.5])
for i=1:5
    text(i+0.1,eigr(i)+0.12,[sprintf('%0.1f',varexplained(i)) '%'],'color','b','fontsize',16);
end

iX = inv(r);
S2 = diag(diag((iX.^-1)));
AIS = S2\inv(r)/S2;
Dai = diag(diag(sqrt(AIS)));
AIR = Dai\AIS/Dai;
AA = sum(sum((AIR - diag(diag(AIR))).^2));
BB = sum(sum((r - eye(size(r))).^2));
kmo = BB/(AA+BB);
disp(['The Kaiser-Meyer-Olkin (KMO) measure of sampling adequacy was ' num2str(kmo)])
%%
disp('PCA loadings (Promax Rotated), 1. Speeding violations, 2. Errors, 3. Non-speeding violations')
disp(lding)
disp(['Cronbach''s alpha PCA 1, for the variables that load more strongly than 0.4 = ' num2str(cronbach(DBQt(:,lding(:,1)>.4)))])
disp(['Cronbach''s alpha PCA 2, for the variables that load more strongly than 0.4 = ' num2str(cronbach(DBQt(:,lding(:,2)>.4)))])
disp(['Cronbach''s alpha PCA 3, for the variables that load more strongly than 0.4 = ' num2str(cronbach(DBQt(:,lding(:,3)>.4)))])
DBQs=zscore(DBQt)/lding';
X(:,73:73+size(DBQs,2)-1)=DBQs; % add three columns with DBQ scores to the X matrix
MX=NaN(22,size(X,2));
SDX=NaN(22,size(X,2));
NN=NaN(22,1);
for i=1:22 % loop of 22 districts
    temp=find(X(:,42)==i);
    NN(i)=sum(~isnan(X(temp,24)));
    if NN(i)>=0
        MX(i,:)=nanmean(X(temp,:));
    end
end
%% Figure at the district level
% http://www.who.int/kobe_centre/measuring/urbanheart/tehran_urbanheart_city_report.pdf
Car=[66.09960781	63.20836672	68.32201746	51.52026315	60.34411504	60.99523468	45.87610172	47.27111711	33.44494581	26.35685067	35.23974191	33.67772952	41.68009109	36.34293426	25.88537933	22.98486062	24.34192215	26.99531902	30.31754734	30.08813731	46.98013748	58.33002994];
IL =[3.260305603	2.790175439	2.58245614	5.78680249	3.681539332	2.792167516	5.026191285	5.028183362	9.192891907	8.312393888	7.346055461	8.859490662	5.823746463	7.00975665	13.95341256	14.66911149	13.95250707	11.39395586	13.95142049	10.32982456	4.863384267	3.615619694];
ED =[43.81732377	42.72109707	47.16155588	26.59936935	37.4367765	45.78122024	31.0519967	26.03591306	17.28673312	17.17033839	21.47059446	17.55920259	21.60286119	17.14705945	8.810022644	11.44530506	10.47446723	11.31409646	9.650180941	13.25048145	23.95932533	30.34410514];
figure;hold on
for i=1:22 % loop of 22 districts
    if NN(i)>=10
        plot(MX(i,1),MX(i,end-2),'ko','Markersize',10,'markerfacecolor','k')
        text(MX(i,1)+0.02,MX(i,end-2),num2str(i),'color','r')
    end
end
xlabel('Proportion of respondents with a Pride')
ylabel('Mean DBQ speeding violations score (\it{z}\rm-score)')
axis equal
set(gca,'xlim',[0 .8],'ylim',[-0.4 0.4],'LooseInset', [0.01 0.01 0.01 0.01])
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',20)
box on;grid on
%%
c=corr(DBQs,X(:,I(I<=43)),'rows','pairwise');
disp('Correlations between DBQ and questionnaire items for the imputed (columns 1-3) and non-imputed dataset (colums 4-6)')
cu=corr(DBQs,Xunfiltered(:,I(I<=43)),'rows','pairwise');
disp([c' cu'])
%%
disp('Correlations between DBQ scores (1 = Speeding violations, 2 = Errors, 3 = Non-speeding violations)')
disp(round(corr(DBQs),2))
%% Correlation between the DBQ component scores and the survey items at the district level (N = 15)
XMM=[Car' IL' ED' MX(:,[1 24 30 35 end-2:end])];XMM=XMM(sum(isnan(XMM),2)==0,:);
c=corr(XMM(NN>=10,:),'type','spearman');
l=pcao(c,1);
eigr=sort(eig(c),'descend');
disp('Percentage variance explained')
disp(100*(eigr./sum(eigr)))
printmat(round(c*100)/100,'Table', 'Car IL ED Pride artQ17spd artQ18trip artQ23edu DBQspd DBQerr DBQnspd','Car IL ED Pride artQ17spd artQ18trip artQ23edu DBQspd DBQerr DBQnspd')
disp('Loadings')
disp(round(-l,2))
c=corr(MX(NN>=10,I(I<=43)),MX(NN>=10,end-2:end),'rows','complete','type','spearman');
disp('Correlation between the DBQ component scores and the survey items at the district level (imputed dataset, N = 15)')
disp(c)
%%
disp('Regression analysis for predicting: How many times have you been issued a traffic ticket for the following traffic violations during the last three years? Exceeding the speed limit (artQ17)')
y=X(:,24);
x=[X(:,40) X(:,35) DBQs]; % Age (artQ26), Education level (artQ23), and the three DBQ scores
temp=find(~isnan(y+sum(x,2)));x=x(temp,:);y=y(temp);
[Br,BINTr]=regress(zscore(y), zscore(x));
st=regstats(zscore(y), zscore(x));
rho=corr(y,x,'rows','pairwise') ;
printmat([round([Br BINTr st.tstat.t(2:end) ]*100)/100,round(1000*st.tstat.pval(2:end))/1000,round(100*rho')/100],'Table', 'Age Educ Vspeeding Error Vnonspeeding','Beta 95%CI_low 95%CI_high t p r0')
%%
disp('Regression analysis for predicting: In the last three years, how many times were you recognised as being at fault in minor and damage accidents? (artQ13)')
y=X(:,19); % artQ13 (In the last three years, how many times were you recognised as being at fault in minor and damage accidents?)
x=[X(:,40) X(:,35) DBQs]; % Age (artQ26), Education level (artQ23), and the three DBQ scores
temp=find(~isnan(y+sum(x,2)));x=x(temp,:);y=y(temp);
[Br,BINTr]=regress(zscore(y), [ones(size(x,1),1) zscore(x)]);
st=regstats(zscore(y), zscore(x));
rho=corr(y,x,'rows','pairwise') ;
[~,~,stats]=mnrfit(zscore(x),Q13(temp),'model','ordinal');
printmat([round([Br BINTr st.tstat.t(1:end) ]*100)/100,round(1000*st.tstat.pval(1:end))/1000,[NaN;round(100*rho')/100],[NaN;round(stats.beta(size(x,2):end)*100)/100],[NaN;round(stats.p(size(x,2):end)*1000)/1000]],'Table', 'Intercept Age Educ Vspeeding Error Vnonspeeding','Beta 95%CI_low 95%CI_high t p r0 Beta_l p_l')
%% Partial correlations between the DBQ scores and the survey items for the imputed dataset (N = 712)
temp=X(:,I(I<=43));
Br=NaN(size(temp,2),3);
for i=1:size(temp,2)
    Br(i,1)=partialcorr(temp(:,i),DBQs(:,1),DBQs(:,[2 3]),'rows','pairwise');
    Br(i,2)=partialcorr(temp(:,i),DBQs(:,2),DBQs(:,[1 3]),'rows','pairwise');
    Br(i,3)=partialcorr(temp(:,i),DBQs(:,3),DBQs(:,[1 2]),'rows','pairwise');
end
%%
disp('Partial correlations between the DBQ scores and the survey items for the imputed dataset (N = 712)')
disp(Br)